Continue to Site

Eng-Tips is the largest engineering community on the Internet

Intelligent Work Forums for Engineering Professionals

  • Congratulations SDETERS on being selected by the Eng-Tips community for having the most helpful posts in the forums last week. Way to Go!

Export part without parameters in displayed part Absolute CSYS

Status
Not open for further replies.

javaxp

Automotive
Jul 14, 2014
43
Hi,
I'm trying to make a journal that exports the solid objects on layers 1 and 100 to a new file without parameters. I've finded this thread: Linkthat was very usefull.

My problem is that the resulting geometry on the new part is positionated relative to the original component (the owner of geometry) Absolute Csys, and I need to be positioned relative to the displayed part Absolute Csys. Any clue?

(On the attached example, I need to export the parts 000000_1000_001 and 000000_1500_001. So, select these files and run the code. The 000000_1000_001 file is "out" of the Root Component Absolute Csys, due that it is a "reusable component. The 000000_1500_001 it´s "on" the root component AbsoluteCsys, due that it is designed in context.)

Thanks in advance,

Javier

My code:

Code:
Imports NXOpen
Imports NXOpen.UF
Imports System.Collections.Generic
Imports System
Imports NXOpen.Assemblies
Imports NXOpenUI
Imports System.IO
Imports System.Windows.Forms


Module Module2



    Public theSession As Session = Session.GetSession()
    Dim s As Session = Session.GetSession()
    Dim selobj As NXObject
    Dim lw As ListingWindow = s.ListingWindow
    'Dim workPart As Part = s.Parts.Work
    Dim theUI As UI = UI.GetUI
    Dim numsel As Integer = theUI.SelectionManager.GetNumSelectedObjects()
    Dim theUISession As UI = UI.GetUI
    Dim ufs As UFSession = UFSession.GetUFSession
    Dim nError As Integer = 0
    Dim origDisplayPart As Part = theSession.Parts.Display
    Dim outputFolder As String = ""
    Dim partLoadStatus1 As NXOpen.PartLoadStatus = Nothing
    Dim dispPart As Part = theSession.Parts.Display
    Const bodyLayer1 As Integer = 1
    Const bodyLayer100 As Integer = 100
    Const curveLayer As Integer = 1
    Dim carpeta As String = Nothing
    Dim workPart As Part
    Dim myComponents As New List(Of Component)()
    Dim j As Integer


    Sub Main()


        lw.Open()

        Dim theSession As Session = Session.GetSession()
        Dim ufs As UFSession = UFSession.GetUFSession

        Dim strPath As String = theSession.Parts.Display.FullPath
        Dim strDir As String = IO.Path.GetDirectoryName(strPath)


        carpeta = strDir
        'lw.WriteFullline("carpeta: " & carpeta)

        Dim FolderBrowserDialog1 As New FolderBrowserDialog

        ' Then use the following code to create the Dialog window
        ' Change the .SelectedPath property to the default location
        With FolderBrowserDialog1
            ' Desktop is the root folder in the dialog.
            .RootFolder = Environment.SpecialFolder.Desktop
            '.RootFolder = Environment.SpecialFolder.MyDocuments
            '.RootFolder = Environment.SpecialFolder.MyPictures
            '.RootFolder = Environment.SpecialFolder.UserProfile

            ' Select the C:\ directory on entry.
            '.SelectedPath = "C:\"
            .SelectedPath = carpeta
            '.SelectedPath = My.Computer.FileSystem.SpecialDirectories.MyDocuments
            '.SelectedPath = My.Computer.FileSystem.SpecialDirectories.Temp

            ' Prompt the user with a custom message.
            .Description = "Selecciona carpeta para guardar DXF de corte"
            If .ShowDialog = DialogResult.OK Then
                outputFolder = .SelectedPath
            Else
                'user pressed cancel, exit journal
                Exit Sub
            End If
        End With








        If numsel > 0 Then


            For inx As Integer = 0 To numsel - 1



                Dim myComp As Component

                selobj = theUI.SelectionManager.GetSelectedObject(inx)

                If TypeOf (selobj) Is Assemblies.Component Then

                    myComp = CType(selobj, Component)

                    myComponents.Add(myComp)

                End If



            Next



            For j = 0 To myComponents.Count - 1



                Dim partLoadStatus1 As NXOpen.PartLoadStatus = Nothing

                theSession.Parts.SetDisplay(myComponents(j).Prototype.OwningPart, True, False, partLoadStatus1)


                Dim Nombre_Salida As String
                Dim OutputFile As String



                'Nombre_Salida = myComponents(j).Prototype.OwningPart.Name
                'Nombre_Salida = Nombre_Salida.Replace(" ", "_")
                'Dim Material As String

                'Material = myComponents(j).GetStringUserAttribute("Material", -1)



                'Dim q As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("Q", -1)
                'Dim qs As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("QS", -1)

                'Dim cantidad As String = "_(" & q & "+" & qs & "S)"


                'Nombre_Salida = Nombre_Salida + "_" + Material + cantidad
                'OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"
                Nombre_Salida = myComponents(j).Prototype.OwningPart.Name & "_" & j.ToString
                OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"

                exportPart(OutputFile)





            Next



            theSession.Parts.SetDisplay(origDisplayPart, False, False, partLoadStatus1)

        Else

            workPart = theSession.Parts.Work

            theSession.Parts.SetDisplay(workPart, True, False, partLoadStatus1)


            Dim Nombre_Salida As String
            Dim OutputFile As String
            'Nombre_Salida = myComponents(j).Prototype.OwningPart.Name
            'Nombre_Salida = Nombre_Salida.Replace(" ", "_")
            'Dim Material As String

            'Material = myComponents(j).GetStringUserAttribute("Material", -1)



            'Dim q As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("Q", -1)
            'Dim qs As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("QS", -1)

            'Dim cantidad As String = "_(" & q & "+" & qs & "S)"


            'Nombre_Salida = Nombre_Salida + "_" + Material + cantidad
            'OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"

            Nombre_Salida = myComponents(j).Prototype.OwningPart.Name & "_" & j.ToString
            OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"



            exportPart(OutputFile)


        End If



        If nError = 0 Then

            theUISession.NXMessageBox.Show("EXPORTACION PRT", NXOpen.NXMessageBox.DialogType.Information, "Se ha realizado la exportación a PRT")

        Else

            theUISession.NXMessageBox.Show("EXPORTACION PRT", NXOpen.NXMessageBox.DialogType.Error, "NO se ha realizado la exportación a PRT")
        End If



    End Sub




    Sub exportPart(partname)

        Dim workPart As Part = theSession.Parts.Work



        Dim stateArray1(0) As NXOpen.Layer.StateInfo
        stateArray1(0) = New NXOpen.Layer.StateInfo(100, NXOpen.Layer.State.Selectable)

        workPart.Layers.ChangeStates(stateArray1, True)



        Dim myOptions As UFPart.ExportOptions
        myOptions.params_mode = UFPart.ExportParamsMode.RemoveParams
        myOptions.new_part = True


        Dim objectTags As New List(Of Tag)



        For Each myObj As Body In workPart.Bodies


            If myObj.Layer = bodyLayer1 Then


                objectTags.Add(myObj.Tag)

            Else


            End If
        Next


        For Each myObj As Body In workPart.Bodies


            If myObj.Layer = bodyLayer100 Then


                objectTags.Add(myObj.Tag)

            Else


            End If
        Next


        'collect curves
        For Each myObj As Curve In workPart.Curves

            If myObj.Layer = curveLayer Then
                objectTags.Add(myObj.Tag)
            End If
        Next



        If objectTags.Count <> 0 Then

            ufs.Part.ExportWithOptions(partname, objectTags.Count, objectTags.ToArray, myOptions)
        Else

            lw.WriteFullline("Componente: " & partname & " no generado.  Generar manualmente ")


        End If











    End Sub


    Public Function GetUnloadOption(ByVal dummy As String) As Integer
        Return CInt(NXOpen.Session.LibraryUnloadOption.Immediately)
    End Function

End Module






NX 12.0.2.9 MP14
 
Replies continue below

Recommended for you

If you would use step export( maybe parasolid), you would be closer to your target, removing the parameters. and/or the assy structure.
If you place your parts in an assembly and use that as the work part, you will get these coordinates from the Work part.
( When exporting using the "Displayed part" option.)
Layers when exporting to step is a little odd, it "only works as one thinks" when using the option "Existing part", and as such the part must therefore be saved with the correct layer settings.


Regards,
Tomas





The more you know about a subject, the more you know how little you know about that subject.
 
Hi Toost,

I´d prefer not go out of NX, but it could be a solution. If there is no other way I will try it.

Thanks for your time.

Regards

Javier

NX 12.0.2.9 MP14
 
This might serve as a starting point.

Code:
Option Strict Off
Imports System
Imports System.Collections.Generic
Imports NXOpen
Imports NXOpen.UF

Module Module4

    Dim theSession As Session = Session.GetSession()
    Dim theUfSession As UFSession = UFSession.GetUFSession()
    Dim lw As ListingWindow = theSession.ListingWindow

    Sub Main()

        If IsNothing(theSession.Parts.BaseWork) Then
            'active part required
            Return
        End If

        Dim workPart As Part = theSession.Parts.Work
        lw.Open()

        Const undoMarkName As String = "export bodies"
        Dim markId1 As Session.UndoMarkId
        markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible, undoMarkName)

        Dim targetLayers As New List(Of Integer)
        targetLayers.Add(1)
        targetLayers.Add(100)

        Dim theBodies As New List(Of Tag)
        theBodies = GetBodiesOnLayers(theSession.Parts.Display, targetLayers)

        Const exportPartName As String = "C:\temp\export_test.prt"

        Dim myOptions As UFPart.ExportOptions
        myOptions.params_mode = UFPart.ExportParamsMode.RemoveParams
        myOptions.new_part = True

        theUfSession.Part.ExportWithOptions(exportPartName, theBodies.Count, theBodies.ToArray, myOptions)

        lw.Close()

    End Sub

    Function GetBodiesOnLayers(ByVal thePart As Part, ByVal layerList As List(Of Integer)) As List(Of Tag)

        Dim theBodies As New List(Of Tag)

        Dim aBodyTag As Tag = Tag.Null
        Do
            theUfSession.Obj.CycleObjsInPart(thePart.Tag,
                UFConstants.UF_solid_type, aBodyTag)
            If aBodyTag = Tag.Null Then
                Exit Do
            End If

            Dim theType As Integer, theSubtype As Integer
            theUfSession.Obj.AskTypeAndSubtype(aBodyTag, theType, theSubtype)
            If theSubtype = UFConstants.UF_solid_body_subtype Then
                Dim tempBody As Body = Utilities.NXObjectManager.Get(aBodyTag)
                If tempBody.IsSheetBody Then
                    Continue Do
                End If
                If layerList.Contains(tempBody.Layer) Then
                    theBodies.Add(aBodyTag)
                End If
            End If
        Loop While True

        Return theBodies

    End Function

    Public Function GetUnloadOption(ByVal dummy As String) As Integer

        'Unloads the image immediately after execution within NX
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.Immediately

    End Function

End Module

www.nxjournaling.com
 
Hi cowsky,

Unfortunately this approach is the same as mine (derived from your answer in thread Link . I do not want to export "all" solids on display part (on a defined layer); what I need is to export the bodies from the "different WorkParts" (cycling on the assembly) with the position relative to DisplayPart Absolute Csys, In such a way that, if I import these differents exported parts in a new part they maintain their relative positions as in the original assembly.

Regards,

Javier



Sorry if I can't be more clear. My difficulties with English prevent me from expressing myself clearly.













NX 12.0.2.9 MP14
 
In a different CAD system that is done by editing the part features in the context of the assembly and adding a coordinate system feature to the part(s) of interest. Then each part contains a reference shared by all the related parts of interest that were in the assembly and can be reassembled with that coordinate system feature to reproduce the assembled location/orientation.

Since this is an export situation, there isn't a need to save that modified part and so the coordinate system will not appear in other places the part might be used. Just be sure to lock their orientation and location in the target assembly so they no longer depend on the coordinate system feature.
 
Hi 3DDave,

If I understand correctly, you refers to another CAD systems different to NX, right?
To do this in NX in a similar way, I would need to add a coordinate system relative to Assembly AbsoluteCsys and then when import I would to reposition the different parts to matching these Csys...well, if can´t get my goal directly, it would be a good subterfuge...

Thanks 3DDave,


Javier

NX 12.0.2.9 MP14
 
I do not understand this.
what You are saying is that you want to export non-parametric solids, where the position of the bodies are from the assembly.
This is, off the shelf , exactly what a step export will do.
And, if you have saved the assembly and use the step-export option "Existing part" you can limit the export to layer 1 and 100.
If you need a different component positions, you can create a "communication assembly" above the main assy, move the components and export the communication assembly.
The used coordinate system is from the Work part, not Displayed part.

Regards,
Tomas



The more you know about a subject, the more you know how little you know about that subject.
 
So you want to export the bodies to individual part files?
That shouldn't be too difficult.

What exactly is your end goal?
If you want to move the native geometry inside of each part file so that it ends up in assembly position, the intermediate exports are not required.


www.nxjournaling.com
 
Hi,

We have several CAM systems (NX, PowerMill, WorkCNC) and to comply with all of theirs we create for each part a new file (prt) with the geometry of the piece and the raw material cleaned of other construction geometries. Then each one of the CAM systems "import" the geometry for generating the CNC programs. Sometimes they require to "mount" several of these parts together in the assembly position. For this is that I require to save "in assembly position".
I think that create new components and ad the geometry through wave wil be the best solution. Doing this interactively seems that "please" the diferent workers, so I will try to do a journal that automates the process. I think I will probably get this goal "cutting" and "pasting" previous journals I've made and searching over the forum that is plenty of useful journals.

Thanks cowsky, DDave and Toost for your support.

Regards,

Javier





NX 12.0.2.9 MP14
 
This version exports out individual files. For my testing, I just output the files to the "MyDocuments" folder; you will want to edit the code to add your folder picker and file naming back in.

Code:
Option Strict Off
Imports System
Imports System.Collections.Generic
Imports NXOpen
Imports NXOpen.UF

Module Module4

    Dim theSession As Session = Session.GetSession()
    Dim theUfSession As UFSession = UFSession.GetUFSession()
    Dim lw As ListingWindow = theSession.ListingWindow

    Dim outputFolder As String = My.Computer.FileSystem.SpecialDirectories.MyDocuments

    Sub Main()

        If IsNothing(theSession.Parts.BaseWork) Then
            'active part required
            Return
        End If

        Dim workPart As Part = theSession.Parts.Work
        lw.Open()

        Const undoMarkName As String = "export bodies"
        Dim markId1 As Session.UndoMarkId
        markId1 = theSession.SetUndoMark(Session.MarkVisibility.Visible, undoMarkName)

        Dim targetLayers As New List(Of Integer)
        targetLayers.Add(1)
        targetLayers.Add(100)

        Dim theBodies As New List(Of Tag)
        theBodies = GetBodiesOnLayers(theSession.Parts.Display, targetLayers)

        Dim j As Integer = 0
        For Each aBodyTag As Tag In theBodies
            Dim exportPartName As String = ""
            Dim aBody As Body = Utilities.NXObjectManager.Get(aBodyTag)
            If aBody.IsOccurrence Then
                exportPartName = IO.Path.Combine(outputFolder, aBody.OwningComponent.Prototype.OwningPart.Name & "_" & j.ToString & ".prt")
            Else
                exportPartName = IO.Path.Combine(outputFolder, aBody.OwningPart.Name & "_" & j.ToString & ".prt")
            End If
            'lw.WriteLine("exportPartName: " & exportPartName)

            Dim myOptions As UFPart.ExportOptions
            myOptions.params_mode = UFPart.ExportParamsMode.RemoveParams
            myOptions.new_part = True

            theUfSession.Part.ExportWithOptions(exportPartName, 1, {aBodyTag}, myOptions)

            j += 1
        Next


        lw.Close()

    End Sub

    Function GetBodiesOnLayers(ByVal thePart As Part, ByVal layerList As List(Of Integer)) As List(Of Tag)

        Dim theBodies As New List(Of Tag)

        Dim aBodyTag As Tag = Tag.Null
        Do
            theUfSession.Obj.CycleObjsInPart(thePart.Tag,
                UFConstants.UF_solid_type, aBodyTag)
            If aBodyTag = Tag.Null Then
                Exit Do
            End If

            Dim theType As Integer, theSubtype As Integer
            theUfSession.Obj.AskTypeAndSubtype(aBodyTag, theType, theSubtype)
            If theSubtype = UFConstants.UF_solid_body_subtype Then
                Dim tempBody As Body = Utilities.NXObjectManager.Get(aBodyTag)
                If tempBody.IsSheetBody Then
                    Continue Do
                End If
                If layerList.Contains(tempBody.Layer) Then
                    theBodies.Add(aBodyTag)
                End If
            End If
        Loop While True

        Return theBodies

    End Function

    Public Function GetUnloadOption(ByVal dummy As String) As Integer

        'Unloads the image immediately after execution within NX
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.Immediately

    End Function

End Module

www.nxjournaling.com
 
Hi,

Finally I've solved it. Per API documentation about UF_PART_export_with_options:
"For V14.0.1, the behavior of this function was modified as follows:
When exporting geometry using this function, the geometry would
not be oriented properly in the destination part if the WCS of the
source part was away from the origin. This is now fixed so that the
geometry is transformed from the WCS of the source part to the
WCS of the destination part. The Open API behavior is now
the same as the interactive behavior."

So, doing te displayPart's WCS and source part's WCS like displayPart AbsoluteCsys the position of the original and exported geometry is the same.

Regards,

Javier



NX 12.0.2.9 MP14
 
This is a lot of flailing about for something that can be accomplished as simply as Export --> Part.
 
Status
Not open for further replies.

Part and Inventory Search

Sponsor